--========================================================--
--                EBFM Encounter                          --
--                                                        --
-- Author      :  kurapica125@outlook.com                 --
-- Create Date :  2017/03/07                              --
--========================================================--

--========================================================--
Scorpio     "EnhanceBattlefieldMinimap.Encounter"    "1.0.0"
--========================================================--

local OLD_Encounter_OnEnter
local MDL_INITED = false
local IN_ENCOUNTER = false

----------------------------------------------
-------------- Module Event Handler ----------
----------------------------------------------
function OnLoad(self)
    _SVDB:SetDefault { ShowEncounter = true }

    EncounterPOI = List()
end

__SlashCmd__("ebfm", "encounter", _Locale["on/off - show boss marks"])
function ToggleQuest(opt)
    if opt == "on" then
        _SVDB.ShowEncounter = true
        EBFM_REFRESH()
    elseif opt == "off" then
        _SVDB.ShowEncounter = false
        EncounterPOI:Each("x=>x:Hide()")
    else
        return false
    end
end

__SystemEvent__()
function EBFM_INITED()
	MDL_INITED = true
end

__SystemEvent__()
function EBFM_REFRESH()
	if not _SVDB.ShowEncounter then return end
	if IN_ENCOUNTER then return end

    local width = BattlefieldMinimap:GetWidth()
    local height = BattlefieldMinimap:GetHeight()
	local bossButton, questPOI, displayInfo, _
	local index = 1
	local x, y, instanceID, name, description, encounterID = EJ_GetMapEncounter(index, false)
	while name do
		bossButton = GetEncounter(index)

		bossButton.instanceID = instanceID
		bossButton.encounterID = encounterID
		bossButton.tooltipTitle = name
		bossButton.tooltipText = description
		bossButton:SetPoint("CENTER", BattlefieldMinimap, "BOTTOMLEFT", x*width, y*height)

		_, _, _, displayInfo = EJ_GetCreatureInfo(1, encounterID)
		bossButton.displayInfo = displayInfo
		if ( displayInfo ) then
			SetPortraitTexture(bossButton.bgImage, displayInfo)
		else
			bossButton.bgImage:SetTexture("DoesNotExist")
		end
		bossButton:Show()
		index = index + 1
		x, y, instanceID, name, description, encounterID = EJ_GetMapEncounter(index, false)
	end

	for i = index, #EncounterPOI do
		EncounterPOI[i]:Hide()
	end
end

__SystemEvent__ "UNIT_PORTRAIT_UPDATE"
function EncounterJournal_UpdateMapButtonPortraits()
	if ( MDL_INITED and BattlefieldMinimapScroll:IsShown() ) then
		local index = 1
		local bossButton = EncounterPOI[index]
		while ( bossButton and bossButton:IsShown() ) do
			SetPortraitTexture(bossButton.bgImage, bossButton.displayInfo)
			index = index + 1
			bossButton = EncounterPOI[index]
		end
	end
end

__SystemEvent__()
function ENCOUNTER_START()
	IN_ENCOUNTER = true
    EncounterPOI:Each("x=>x:Hide()")
end

__SystemEvent__()
function ENCOUNTER_END()
	IN_ENCOUNTER = false
	EBFM_REFRESH()
end

function GetEncounter(index)
	local frame = EncounterPOI[index]
	while #EncounterPOI < index do
		frame = CreateFrame("Button", "Test"..index, BattlefieldMinimap, "EncounterMapButtonTemplate")
		frame:SetSize(12, 12)
		frame.bgImage:SetSize(8, 8)
		frame:SetFrameStrata("High")
		EncounterPOI:Insert(frame)
		if not OLD_Encounter_OnEnter then
			OLD_Encounter_OnEnter = frame:GetScript("OnEnter")
		end
		frame:SetScript("OnEnter", Encounter_OnEnter)
	end
	return frame
end

function Encounter_OnEnter(self)
	WorldMap_HijackTooltip(BattlefieldMinimapScroll)
	OLD_Encounter_OnEnter(self)
end
